// (C) 2001 SyGem Software

import java.awt.*;
import java.applet.*;

import com.sygem.jazz3d3.*;
import com.sygem.jazz3d3.primitive.Sphere3d;

public class apptest extends Frame implements Runnable {
        Thread m_ce;
        World myWorld;
        int light1;
        int pid;

        //Construct the application
        public apptest() {

				setTitle("Jazz3D test");
                myWorld = new World();
                setLayout(new BorderLayout());
                add("Center",myWorld);

				Texture t1 = TextureLoader.loadImage("images/Metal.gif");
				Texture t2 = TextureLoader.loadImage("images/Jazz3D_logo_large.gif");

                RenderTexturedHQ tex = new RenderTexturedHQ();
                tex.setDrawingMode(Render.GOURAUD);
                tex.setTexture(t2);
                tex.wrapUV(true);
                tex.setEnvironmentMap(t1);
                tex.setEnvMapping(true);
                tex.setReflectivity(1);

                Sphere3d sp1 = new Sphere3d(15,15,0,0,8);
                sp1.setRenderer(tex);
                pid = myWorld.addObject(sp1);

                Light l1 = new Light(0,0,1);
                myWorld.addLight(l1);

                resize(400,300);
                validate();
                show();

				m_ce = new Thread(this);
				m_ce.start();

        }

        public void run() {
                int iCount = 0;
                long lTime0 = System.currentTimeMillis();
                double x,y,z;
                x = 0.6;
                y = 0.2;
                z = 0.4;
                myWorld.prep();
                while (true) {
                        myWorld.getParentObject(pid).rotateLocal(x,y,z);
                        myWorld.redraw();
                        iCount++;
                        if((iCount%50) == 0) {
                                lTime0-= System.currentTimeMillis();
                                lTime0 =-lTime0;
                                System.out.println((50000./lTime0)+" frames/second");
                                lTime0 = System.currentTimeMillis();
                        }
                }
        }

	public static void main( String[] args ) {
		apptest t = new apptest();
	}

}